       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRI2WRD.
      **** rel 7.1
      * Nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           SELECT FILAUT ASSIGN TO DISK
                  ORGANIZATION SEQUENTIAL
                  STATUS SF-FAU.
      *
           SELECT FILEFX ASSIGN TO NOMEFILE
                  ORGANIZATION SEQUENTIAL.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'grimaut'.
       FD  FILEFX LABEL RECORD OMITTED DATA RECORD RF-FFX.
       01  RF-FFX.  
           05 INFO.
              10 D-TIPS      PIC X.
              10 SP01        PIC X.
              10 D-NCOP      PIC 9.
              10 SP02        PIC X.
      * d-fax: non gestito
              10 D-FAXT      PIC X(30).
              10 SP03        PIC X.
      * d-totpag: e' valorizzato correttamente solo sull'ultimo record.
              10 D-TOTPAG    PIC 9(5).
              10 SP04        PIC X.
              10 D-FLGS    PIC X.
              10 SP05        PIC X.
              10 D-IDDOC   PIC X(50).
              10 SP06        PIC X.
           05 TESTA.
              10 D-FAUA-CDF    PIC X(5).
              10 SP07        PIC X.
              10 D-FAUA-TFO    PIC 9(2).
              10 SP08        PIC X.
              10 D-FAUA-CFFO   PIC X(16).
              10 SP09        PIC X.
              10 D-FAUA-PRGI   PIC 9(4).
              10 SP10        PIC X.
              10 D-FAUA-TOTI   PIC 9(4).
              10 SP11        PIC X.
              10 D-FAUB-CFDI   PIC X(16).
              10 SP12        PIC X.
              10 D-FAUB-PRMO   PIC 9(8).
              10 SP13        PIC X.
              10 D-FAUB-NRPR   PIC X(25).
              10 SP14        PIC X.
              10 D-FAUB-IDDI   PIC X(14).
              10 SP15        PIC X.
              10 D-FAUB-PSWG   PIC X(16).
              10 SP16        PIC X.
              10 D-FAUB-FLGC   PIC X.
              10 SP17        PIC X.
              10 D-FAUB-DANN   PIC X.
              10 SP18        PIC X.
              10 D-FAUB-DSOS   PIC X.
              10 SP19        PIC X.
              10 D-FAUB-DEVE   PIC X.
              10 SP191       PIC X.
              10 D-FAUB-COGN   PIC X(24).
              10 SP20        PIC X.
              10 D-FAUB-NOME   PIC X(20).
              10 SP21        PIC X.
              10 D-FAUB-DENO   PIC X(60).
              10 SP22        PIC X.
              10 D-FAUB-EMAIL  PIC X(100).
              10 SP23        PIC X.
              10 D-FAUB-NTEL   PIC X(12).
              10 SP24        PIC X.
              10 D-FAUB-CFISC  PIC X(16).
              10 SP25        PIC X.
              10 D-FAUB-CODC   PIC ZZ.
              10 SP26        PIC X.
              10 D-FAUB-CNF    PIC X(24).
              10 SP27        PIC X.
              10 D-FAUB-NOF    PIC X(20).
              10 SP28        PIC X.
              10 D-FAUB-CFSOC  PIC X(11).
              10 SP29        PIC X.
              10 D-FAUB-NDIP   PIC 9(8).
              10 SP30        PIC X.
              10 D-FAUB-NAUT   PIC ZZZZZZZ9.
              10 SP31        PIC X.
              10 D-FAUB-QCT    PIC 9.
              10 SP32        PIC X.
              10 D-FAUB-FIRMA  PIC X(32).
              10 SP33        PIC X.
              10 D-FAUB-CFISI  PIC X(16).
              10 SP34        PIC X.
              10 D-FAUB-IMPEG  PIC X.
              10 SP35        PIC X.
              10 D-FAUB-DTIMgg PIC X(2).
              10 SP36        PIC X.
              10 D-FAUB-DTIMmm PIC X(2).
              10 SP37        PIC X.
              10 D-FAUB-DTIMaa PIC X(4).
              10 SP38        PIC X.
              10 D-FAUB-FIRMAI PIC 9.
              10 SP39        PIC X.
              10 D-FAUD-TOPES    PIC X.
              10 SP40        PIC X.
              10 D-FAUD-TOPEA    PIC X.
              10 SP41        PIC X.
              10 D-FAUD-ANNOF  PIC 9999.
              10 SP42        PIC X.
              10 D-FAUD-NRMO   PIC 99.
              10 SP43        PIC X.
              10 D-FAUD-DA001001 PIC X(16).
              10 SP44        PIC X.
              10 D-FAUD-DA001002 PIC X(61).
              10 SP45        PIC X.
              10 D-FAUD-DA001003 PIC X(31).
              10 SP46        PIC X.
              10 D-FAUD-DA001004 PIC X(31).
              10 SP47        PIC X.
              10 D-FAUD-DA001005 PIC X(2).
              10 SP48        PIC X.
              10 D-FAUD-DA001006 PIC X(10).
              10 SP49        PIC X.
              10 D-FAUD-DA001007 PIC X(91).
              10 SP50        PIC X.
              10 D-FAUD-DA001008 PIC X(12).
              10 SP51        PIC X.
              10 D-FAUD-DA001009 PIC X(106).
              10 SP52        PIC X.
              10 D-FAUD-DA001010 PIC X(8).
              10 SP53        PIC X.
              10 D-FAUD-DA002001 PIC X(16).
              10 SP54        PIC X.
              10 D-FAUD-DA002002 PIC X(61).
              10 SP55        PIC X.
              10 D-FAUD-DA002003 PIC X(31).
              10 SP56        PIC X.
              10 D-FAUD-DA002004 PIC X(1).
              10 SP57        PIC X.
              10 D-FAUD-DA002005gg PIC X(2).
              10 SP58        PIC X.
              10 D-FAUD-DA002005mm PIC X(2).
              10 SP59        PIC X.
              10 D-FAUD-DA002005aa PIC X(4).
              10 SP60        PIC X.
              10 D-FAUD-DA002006 PIC X(31).
              10 SP61        PIC X.
              10 D-FAUD-DA002007 PIC X(2).
              10 SP62        PIC X.
              10 D-FAUD-DA002008 PIC X(2).
              10 SP63        PIC X.
              10 D-FAUD-DA002020 PIC X(31).
              10 SP64        PIC X.
              10 D-FAUD-DA002021 PIC X(2).
              10 SP65        PIC X.
              10 D-FAUD-DA002022 PIC X(4).
              10 SP66        PIC X.
              10 D-FAUD-DA002023 PIC X(4).
              10 SP67        PIC X.
              10 D-FAUD-DA002024 PIC X(31).
              10 SP68        PIC X.
              10 D-FAUD-DA002025 PIC X(2).
              10 SP681       PIC X.
              10 D-FAUD-DA002026 PIC X(4).
              10 SP69        PIC X.
              10 D-FAUD-DA002027 PIC X(4).
              10 SP691       PIC X.
              10 D-FAUD-DA002040 PIC X(16).
              10 SP70        PIC X.
              10 D-FAUD-DA002041 PIC X(61).
              10 SP71        PIC X.
              10 D-FAUD-DA002042 PIC X(106).
      **** rel 7.2
              10 SP100       PIC X.
              10 D-FAUD-DA002SHU PIC X.
      ************
              10 SP72        PIC X.
              10 D-FAUD-DA002043 PIC ZZ9.
              10 SP73        PIC X.
              10 D-FAUD-DA003001gg PIC X(2).
              10 SP74        PIC X.
              10 D-FAUD-DA003001mm PIC X(2).
              10 SP75        PIC X.
              10 D-FAUD-DA003001aa PIC X(4).
              10 SP76        PIC X.
              10 D-FAUH-AU001001 PIC XX.
              10 SP77        PIC X.
              10 D-FAUH-AU001002 PIC ZZZ9.
              10 SP78        PIC X.
              10 D-FAUH-AU001003 PIC X.
              10 SP79        PIC X.
              10 D-FAUH-AU001004 PIC X(16).
              10 SP80        PIC X.
              10 D-FAUH-AU001005 PIC X(16).
              10 SP81        PIC X.
              10 D-FAUH-AU001006 PIC X.
              10 SP82        PIC X.
              10 D-FAUH-AU001007 PIC X(16).
              10 SP83        PIC X.
              10 D-FAUH-AU001008 PIC X(16).
              10 SP84        PIC X.
              10 D-FAUH-AU001009 PIC X(16).
              10 SP85        PIC X.
              10 D-FAUH-AU001010 PIC X(16).
              10 SP86        PIC X.
              10 D-FAUH-AU001011 PIC X(16).
              10 SP87        PIC X.
              10 D-FAUH-AU001020 PIC X(16).
              10 SP89        PIC X.
              10 D-FAUH-AU001021 PIC X(16).
              10 SP90        PIC X.
              10 D-FAUH-AU001022 PIC X(16).
              10 SP91        PIC X.
              10 D-FAUH-AU001023 PIC X(16).
              10 SP92        PIC X.
      **** rel 7.2
              10 D-FAUH-AU001071 PIC X(16).
              10 SP101       PIC X.
      ************
           05 XTAPPO PIC XX.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parab'.
           COPY 'parwo'.
           COPY 'parrm'.
           COPY 'parop'.
           COPY 'parul'.
           COPY 'parrd'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-FAU PIC X(80) VALUE 'cru15'.
      * parametri chiamata X"91" per scrittura corretta carattere TAB
       01  RX-91      PIC 99 COMP-X.
       01  FX-91      PIC 99 COMP-X VALUE 47.
      *
       01  SLEEPSEC     PIC 9(6).
      *
       01  COMODI.
           05 SF-AZI     PIC XX.
           05 SF-FAU  PIC XX.
           05 NPAG       PIC 999.
           05 MESS       PIC X(40) VALUE SPACE.
           05 CODCLI     PIC 9(7).
           05 TIPPER     PIC 9.
           05 K          PIC 99.
           05 VETTORE-VALORI.
              10 VET-A PIC S9(11)V99 COMP-3 OCCURS 34.
           05 DATI-INTERI PIC X(1800).
           05 DATI-DIVISI REDEFINES DATI-INTERI OCCURS 75.
              10 IDE PIC X(8).
              10 VAL PIC X(16).
           05 CONT PIC 9(5).
           05 TOTPAG PIC 9(5).
           05 OLDREC PIC X.
           05 OLDIDE PIC X(8).
           05 CONTIDE PIC 9(5).
           05 CARSTAR PIC 9(5).
           05 K1      PIC 9(5).
           05 K2      PIC 9(5).
      **** rel 7.2
           05 ANNO    PIC 9(2).
      ************
      *
           05 COMFAUA.
              10 COM-FAUA-TRA    PIC X.
              10 COM-FAUA-FIL1   PIC X(14).
              10 COM-FAUA-CDF    PIC X(5).
              10 COM-FAUA-TFO    PIC 9(2).
              10 COM-FAUA-CFFO   PIC X(16).
              10 COM-FAUA-FIL2   PIC X(483).
              10 COM-FAUA-PRGI   PIC 9(4).
              10 COM-FAUA-TOTI   PIC 9(4).
              10 COM-FAUA-FIL5A  PIC X(1368).
              10 COM-FAUA-FIL6   PIC X.
              10 COM-FAUA-VACR   PIC X.
              10 COM-FAUA-VALF   PIC X.
           05 COMFAUB.
              10 COM-FAUB-TRB    PIC X.
              10 COM-FAUB-CFDI   PIC X(16).
              10 COM-FAUB-PRMO   PIC 9(8).
              10 COM-FAUB-FIL0   PIC X(1).
              10 COM-FAUB-FIL01  PIC X(8).
              10 COM-FAUB-NRPR   PIC X(25).
              10 COM-FAUB-IDDI   PIC X(14).
              10 COM-FAUB-PSWG   PIC X(16).
              10 COM-FAUB-FLGC   PIC X.
              10 COM-FAUB-DANN   PIC 9.
              10 COM-FAUB-DSOS   PIC 9.
              10 COM-FAUB-COGN   PIC X(24).
              10 COM-FAUB-NOME   PIC X(20).
              10 COM-FAUB-DENO   PIC X(60).
              10 COM-FAUB-EMAIL  PIC X(100).
              10 COM-FAUB-NTEL   PIC X(12).
              10 COM-FAUB-DEVE   PIC 9.
              10 COM-FAUB-CFISC  PIC X(16).
              10 COM-FAUB-CODC   PIC 9(2).
              10 COM-FAUB-CNF    PIC X(24).
              10 COM-FAUB-NOF    PIC X(20).
              10 COM-FAUB-CFSOC  PIC X(11).
              10 COM-FAUB-FILL80 PIC X(19).
              10 COM-FAUB-NAUT   PIC 9(8).
              10 COM-FAUB-QCT    PIC 9.
              10 COM-FAUB-FIRMA  PIC 9.
              10 COM-FAUB-CFISI  PIC X(16).
              10 COM-FAUB-IMPEG  PIC 9.
              10 COM-FAUB-DTIM   PIC 9(8).
              10 COM-FAUB-FIRMAI PIC 9.
              10 COM-FAUB-FIL22  PIC X(1).
              10 COM-FAUB-FIL24  PIC X(40).
              10 COM-FAUB-FIL25  PIC X(2).
              10 COM-FAUB-FIL26  PIC X(5).
              10 COM-FAUB-FIL27  PIC X(35).
              10 COM-FAUB-FIL28  PIC X(6).
              10 COM-FAUB-FIL29  PIC X(3).
              10 COM-FAUB-FIL30  PIC X(8).
              10 COM-FAUB-FIL31  PIC X(1).
              10 COM-FAUB-FIL32  PIC X(1305).
              10 COM-FAUB-FIL33  PIC X(20).
              10 COM-FAUB-FIL34  PIC X(7).
              10 COM-FAUB-FIL35  PIC X(3).
              10 COM-FAUB-FIL36  PIC X(3).
              10 COM-FAUB-FIL37  PIC X(1).
              10 COM-FAUB-FIL38  PIC X(1).
              10 COM-FAUB-FIL39  PIC X(1).
              10 COM-FAUB-FIL40  PIC X(1).
              10 COM-FAUB-FIL41  PIC X(1).
              10 COM-FAUB-FIL42  PIC X(1).
              10 COM-FAUB-FIL43  PIC X(15).
              10 COM-FAUB-FIL99  PIC X.
              10 COM-FAUB-VACR   PIC X.
              10 COM-FAUB-VALF   PIC X.
      *
           05 INDR       PIC 99.
           05 MAXR       PIC 99.

           05 NOMEFILE   PIC X(80).
           05 TAPPO      PIC XX    VALUE X'0D0A'.
           05 SEPAR      PIC X     VALUE X'09'.
           05 SWSTAMPA   PIC 9     VALUE ZERO.
           05 SAVPATH    PIC X(50) VALUE SPACE.
           05 COMCNT     PIC 999   VALUE ZERO.
      *
      *    COPY 'vplawrd.cpy'.
      *---------------------------------------------------------
      * Parametri CBL_CHECK_EXIST_FILE
       01  FILE-NAME          PIC X(60).
       01  FILE-DETAILS.
           05 FILE-SIZE       PIC X(8) COMP-X.
           05 FILE-DATE.
              10 F-DAY        PIC X  COMP-X.
              10 F-MONTH      PIC X  COMP-X.
              10 F-YEAR       PIC X(2) COMP-X.
           05 FILE-TIME.
              10 F-HOURS      PIC X COMP-X.
              10 F-MINUTES    PIC X COMP-X.
              10 F-SECONDS    PIC X COMP-X.
              10 F-HINDREDTHS PIC X COMP-X.
       01  STATUS-CODE        PIC X(2)   COMP-X.
      *---------------------------------------------------------
       LINKAGE SECTION.
           COPY 'parwri2'.
       PROCEDURE DIVISION USING PARWRI2 PARCCD.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==FAU==
                                   ==NFILE== BY ==FILAUT==
                                   =='nfile'== BY =='FILAUT'==.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
      *
           MOVE ZERO TO PCCD-ERR.

      * Inizializza
           IF PCCD-FUN = 'T' OR 'I'
              PERFORM PGM-INI THRU EX-PGM-INI
              IF SWSTAMPA = 9 GO TO CHIUDI.

      * Esegue
           IF PCCD-FUN = 'T' OR 'R'
              PERFORM PGM-RUN THRU EX-PGM-RUN.

      * Chiude
           IF PCCD-FUN = 'T' OR 'E'
              PERFORM PGM-END THRU EX-PGM-END
              GO TO CHIUDI.

           GO TO FINE.
       ERRIO.
           COPY 'errsub'.
           MOVE 9 TO PCCD-ERR.
       CHIUDI.
           CLOSE ANAAZI FILAUT.
       FINE.
           EXIT PROGRAM.
      *-------------------*
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'grixxxer'.
      *------------------------------------------*
       PGM-END.
           CLOSE FILEFX.
      *
           IF SWSTAMPA = ZERO
      * Nessuna stampa word eseguita
      *       MOVE 1 TO PCCD-ERR
              GO TO EX-PGM-END.

           MOVE 'R' TO WO-FUN.
           CALL 'vrword' USING PARWO.

           IF PCCD-PATH = SPACE GO TO EX-PGM-END.

      * Attesa eliminazione file "D-" (semaforo fine salvataggio
      * file di stampa unione)
           MOVE 20 TO COMCNT. 
           PERFORM UNTIL COMCNT = ZERO OR 999
              SUBTRACT 1 FROM COMCNT

              MOVE 5 TO SLEEPSEC
              CALL 'vrsleep' USING SLEEPSEC

              MOVE NOMEFILE TO FILE-NAME
              CALL "CBL_CHECK_FILE_EXIST" USING FILE-NAME
                                                FILE-DETAILS
                                  RETURNING STATUS-CODE
              IF STATUS-CODE NOT = ZERO MOVE 999 TO COMCNT.

           IF COMCNT = 999 GO TO EX-PGM-END.

      * Timeout attesa cancellazione semaforo
           MOVE 2 TO PCCD-ERR.
       EX-PGM-END.
           EXIT.
      *------------------------------------------*
       PGM-INI.
           COPY 'strsub'.
           MOVE ZERO TO SWSTAMPA.
           MOVE SPACE TO SAVPATH.
      *
           OPEN INPUT ANAAZI.
      *
           MOVE PWRI2-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
      *
           MOVE 'I'       TO WO-FUN.
           MOVE 'cerri2' TO WO-IDDOC.
           MOVE PWRI2-AZI TO WO-AZI.
           CALL 'vrword' USING PARWO.
           IF WO-ST > ZERO
              MOVE 9 TO SWSTAMPA
              GO TO EX-PGM-INI.

           MOVE 'L' TO WO-TIPRUN.
           MOVE WO-NRIGHE TO MAXR.
      *
           MOVE SPACE TO NOMEFILE.
           STRING WO-DIROUT '\d-' WO-IDDOC '.doc' DELIMITED SPACE
                                                  INTO NOMEFILE.
           OPEN OUTPUT FILEFX.
           CALL X'91' USING RX-91 FX-91 FILEFX.
       EX-PGM-INI.
           EXIT.
      *------------------------------------------*
       PGM-RUN.
           STRING PWRI2-NFILE DELIMITED SPACE INTO ID-FAU.
           OPEN INPUT FILAUT.
           IF SF-FAU NOT = ZERO
              MOVE 'FILE INESISTENTE' TO MESS
              GO TO ERRIO.
           IF SAVPATH = SPACE AND PCCD-PATH NOT = SPACE
              STRING PCCD-PATH DELIMITED SPACE
                     '\ri2'
                     PWRI2-AZI
                     '.doc'
                     DELIMITED SIZE INTO SAVPATH
              MOVE SAVPATH TO PCCD-PATH.
      *
           MOVE ZERO TO NPAG.
      *
           PERFORM AZZ-REC THRU EX-AZZ-REC.
      *
           MOVE ZERO TO TOTPAG.
       INIZIO-CONTA.
           READ FILAUT AT END GO TO FINE-CONTA.
           IF RF-MFAU(1:1) = 'H'
              ADD 1 TO TOTPAG.
           GO TO INIZIO-CONTA.
       FINE-CONTA.
           CLOSE FILAUT.
      *
           OPEN INPUT FILAUT.
       INIZIO-LETTURA.
           READ FILAUT AT END GO TO FINE-LETTURA.
           IF RF-MFAU(1:1) = 'A'
              MOVE RF-MFAU TO COMFAUA.
           IF RF-MFAU(1:1) = 'B'
              MOVE RF-MFAU TO COMFAUB.
           IF RF-MFAU(1:1) = 'D'
              PERFORM STAMPA-RECA THRU EX-STAMPA-RECA
              PERFORM STAMPA-RECB THRU EX-STAMPA-RECB
              PERFORM STAMPA-RECD THRU EX-STAMPA-RECD.
           IF RF-MFAU(1:1) = 'H'
              PERFORM STAMPA-RECH THRU EX-STAMPA-RECH.
           GO TO INIZIO-LETTURA.
       FINE-LETTURA.
           CLOSE FILAUT.
       EX-PGM-RUN.
           EXIT.
      *------------------------------------------*
       SCR-REC.
           MOVE SPACE TO D-FLGS.
           IF PCCD-FLGS = 0
              MOVE 'S' TO D-FLGS.
           MOVE PCCD-PATH TO D-IDDOC.
      *
           MOVE TAPPO TO XTAPPO.
           WRITE RF-FFX.
           MOVE 1 TO SWSTAMPA.
       EX-SCR-REC.
           EXIT.
      *-------------------------------
       AZZ-REC.
           MOVE SPACE TO RF-FFX.
           PERFORM CAR-SEPARATORE THRU EX-CAR-SEPARATORE.
       EX-AZZ-REC.
           EXIT.
      *-------------------------------
       STAMPA-RECA.
      *
           PERFORM AZZ-REC THRU EX-AZZ-REC.
      *
           ADD 1 TO NPAG.
      *
           MOVE 1       TO D-NCOP.
           MOVE SPACE   TO D-FAXT.
           MOVE TOTPAG  TO D-TOTPAG.    
           MOVE SPACE   TO D-TIPS.
      *
           MOVE COM-FAUA-CDF  TO D-FAUA-CDF.
           MOVE COM-FAUA-TFO  TO D-FAUA-TFO.
           MOVE COM-FAUA-CFFO TO D-FAUA-CFFO.
           MOVE COM-FAUA-PRGI TO D-FAUA-PRGI.
           MOVE COM-FAUA-TOTI TO D-FAUA-TOTI.
       EX-STAMPA-RECA.
           EXIT.
      *-------------------------------
       STAMPA-RECB.
           MOVE COM-FAUB-CFDI    TO D-FAUB-CFDI.
           MOVE COM-FAUB-PRMO    TO D-FAUB-PRMO.
           MOVE COM-FAUB-NRPR    TO D-FAUB-NRPR.
           MOVE COM-FAUB-IDDI    TO D-FAUB-IDDI.
           MOVE COM-FAUB-PSWG    TO D-FAUB-PSWG.
           MOVE COM-FAUB-FLGC    TO D-FAUB-FLGC.
           MOVE SPACE        TO D-FAUB-DANN.
           MOVE SPACE        TO D-FAUB-DSOS.
           MOVE SPACE        TO D-FAUB-DEVE.
      *
           IF COM-FAUB-DANN = 1
              MOVE 'X' TO D-FAUB-DANN.
           IF COM-FAUB-DSOS = 1
              MOVE 'X' TO D-FAUB-DSOS.
           IF COM-FAUB-DEVE NOT = ZERO
              MOVE COM-FAUB-DEVE TO D-FAUB-DEVE.
           MOVE COM-FAUB-COGN    TO D-FAUB-DENO.
           IF COM-FAUB-COGN = SPACE
              MOVE COM-FAUB-DENO TO D-FAUB-DENO.
           MOVE COM-FAUB-NOME    TO D-FAUB-NOME.
           MOVE COM-FAUB-EMAIL   TO D-FAUB-EMAIL.
           MOVE COM-FAUB-NTEL    TO D-FAUB-NTEL.
           MOVE COM-FAUB-CFISC   TO D-FAUB-CFISC.
           MOVE COM-FAUB-CODC    TO D-FAUB-CODC.
           MOVE COM-FAUB-CNF     TO D-FAUB-CNF.
           MOVE COM-FAUB-NOF     TO D-FAUB-NOF.
           MOVE COM-FAUB-CFSOC   TO D-FAUB-CFSOC.
           IF COM-FAUB-CFSOC = ZERO
              MOVE SPACE TO D-FAUB-CFSOC.
      *    MOVE COM-FAUB-NDIP    TO D-FAUB-NDIP.
           MOVE COM-FAUB-NAUT    TO D-FAUB-NAUT.
           MOVE COM-FAUB-QCT     TO D-FAUB-QCT.
           MOVE PWRI2-FIRMA      TO D-FAUB-FIRMA.
           MOVE COM-FAUB-CFISI   TO D-FAUB-CFISI.
           MOVE COM-FAUB-IMPEG   TO D-FAUB-IMPEG.
           IF D-FAUB-IMPEG = ZERO
              MOVE SPACE TO D-FAUB-IMPEG.
           MOVE COM-FAUB-DTIM(1:2) TO D-FAUB-DTIMgg.
           MOVE COM-FAUB-DTIM(3:2) TO D-FAUB-DTIMmm.
           MOVE COM-FAUB-DTIM(5:4) TO D-FAUB-DTIMaa.
           IF COM-FAUB-DTIM = ZERO
                   MOVE SPACE TO D-FAUB-DTIMgg D-FAUB-DTIMmm
                                 D-FAUB-DTIMaa.
           MOVE COM-FAUB-FIRMAI  TO D-FAUB-FIRMAI.
       EX-STAMPA-RECB.
           EXIT.
      *-------------------------------
       STAMPA-RECH.
           MOVE SPACE     TO DATI-INTERI.
           MOVE FAUH-FIL1 TO DATI-INTERI.
           MOVE 1 TO CONT. 
           MOVE ZERO TO CONTIDE.
           MOVE SPACE TO OLDIDE.
       LEGGI-DATI2.
           IF IDE(CONT) = SPACE
              GO TO FINE-DATI2.
           IF IDE(CONT) = OLDIDE
              PERFORM STRINGA-NEW THRU EX-STRINGA-NEW
              GO TO SUMM2
           ELSE
              MOVE ZERO TO CONTIDE.
      *
           IF IDE(CONT) = 'AU001001'
              MOVE VAL(CONT) TO D-FAUH-AU001001.
           IF IDE(CONT) = 'AU001002'
              MOVE VAL(CONT)(13:4) TO D-FAUH-AU001002.
           IF IDE(CONT) = 'AU001003'
              IF VAL(CONT)(16:1) = '0'
                 MOVE SPACE TO D-FAUH-AU001003
              ELSE
                 MOVE 'X'   TO D-FAUH-AU001003.
           IF IDE(CONT) = 'AU001004'
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001004.
           IF IDE(CONT) = 'AU001005'
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001005.
           IF IDE(CONT) = 'AU001006'
              MOVE VAL(CONT)(16:1) TO D-FAUH-AU001006.
           IF IDE(CONT) = 'AU001007'
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001007.
           IF IDE(CONT) = 'AU001008'
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001008.
           IF IDE(CONT) = 'AU001009'
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001009.
           IF IDE(CONT) = 'AU001010'
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001010.
           IF IDE(CONT) = 'AU001011'
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001011.
      **** rel 7.2
      *    IF IDE(CONT) = 'AU001020'
           IF IDE(CONT) = 'AU001034'
      ************
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001020.
      **** rel 7.2
      *    IF IDE(CONT) = 'AU001021'
           IF IDE(CONT) = 'AU001035'
      ************
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001021.
      **** rel 7.2
      *    IF IDE(CONT) = 'AU001022'
           IF IDE(CONT) = 'AU001020'
      ************
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001022.
      **** rel 7.2
      *    IF IDE(CONT) = 'AU001023'
           IF IDE(CONT) = 'AU001021'
      ************
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001023.
      *
      **** rel 7.2
           IF IDE(CONT) = 'AU001071'
              MOVE VAL(CONT) TO D-FAUH-AU001071.
      *
      ************
       SUMM2.
           MOVE IDE(CONT) TO OLDIDE.
           ADD 1 TO CONTIDE.
           ADD 1 TO CONT.
           GO TO LEGGI-DATI2.
       FINE-DATI2.
      *
           PERFORM SCR-REC THRU EX-SCR-REC.
           MOVE ZERO TO NPAG.
       EX-STAMPA-RECH.
           EXIT.
      *-------------------------------
       STAMPA-RECD.
           MOVE FAUD-PRGC TO D-FAUD-NRMO.
           MOVE SPACE TO D-FAUD-TOPES D-FAUD-TOPEA.
           IF FAUD-TOPE NOT = SPACE
              IF FAUD-TOPE = 'S'
                 MOVE 'X' TO D-FAUD-TOPES
              ELSE
                 MOVE 'X' TO D-FAUD-TOPEA.
      *
           MOVE 20 TO D-FAUD-ANNOF(1:2).
           MOVE COM-FAUA-CDF(4:2) TO ANNO.
           COMPUTE ANNO = ANNO - 1.
           MOVE ANNO TO D-FAUD-ANNOF(3:2).
           
      *
           MOVE SPACE     TO DATI-INTERI.
           MOVE FAUD-FIL1 TO DATI-INTERI.
           MOVE 1 TO CONT. 
           MOVE ZERO TO CONTIDE.
           MOVE SPACE TO OLDIDE.
       LEGGI-DATI.
           IF IDE(CONT) = SPACE
              GO TO FINE-DATI.
           IF IDE(CONT) = OLDIDE
              PERFORM STRINGA-NEW THRU EX-STRINGA-NEW
              GO TO SUMM
           ELSE
              MOVE ZERO TO CONTIDE.
      *
           IF IDE(CONT) = 'DA001001'
              MOVE VAL(CONT) TO D-FAUD-DA001001.
           IF IDE(CONT) = 'DA001002'
              MOVE VAL(CONT) TO D-FAUD-DA001002.
           IF IDE(CONT) = 'DA001003'
              MOVE VAL(CONT) TO D-FAUD-DA001003.
           IF IDE(CONT) = 'DA001004'
              MOVE VAL(CONT) TO D-FAUD-DA001004.
           IF IDE(CONT) = 'DA001005'
              MOVE VAL(CONT) TO D-FAUD-DA001005.
           IF IDE(CONT) = 'DA001006'
              MOVE VAL(CONT) TO D-FAUD-DA001006.
           IF IDE(CONT) = 'DA001007'
              MOVE VAL(CONT) TO D-FAUD-DA001007.
           IF IDE(CONT) = 'DA001008'
              MOVE VAL(CONT) TO D-FAUD-DA001008.
           IF IDE(CONT) = 'DA001009'
              MOVE VAL(CONT) TO D-FAUD-DA001009.
           IF IDE(CONT) = 'DA001010'
              MOVE VAL(CONT) TO D-FAUD-DA001010.
      *
           IF IDE(CONT) = 'DA002001'
              MOVE VAL(CONT) TO D-FAUD-DA002001.
           IF IDE(CONT) = 'DA002002'
              MOVE VAL(CONT) TO D-FAUD-DA002002.
           IF IDE(CONT) = 'DA002003'
              MOVE VAL(CONT) TO D-FAUD-DA002003.
           IF IDE(CONT) = 'DA002005'
              MOVE VAL(CONT)(9:2)  TO D-FAUD-DA002005gg
              MOVE VAL(CONT)(11:2) TO D-FAUD-DA002005mm
              MOVE VAL(CONT)(13:4) TO D-FAUD-DA002005aa
              IF VAL(CONT)(9:8) = ZERO
                   MOVE SPACE TO D-FAUD-DA002005gg D-FAUD-DA002005mm
                                 D-FAUD-DA002005aa.
           IF IDE(CONT) = 'DA002004'
              MOVE VAL(CONT) TO D-FAUD-DA002004.
           IF IDE(CONT) = 'DA002006'
              MOVE VAL(CONT) TO D-FAUD-DA002006.
           IF IDE(CONT) = 'DA002007'
              MOVE VAL(CONT) TO D-FAUD-DA002007.
           IF IDE(CONT) = 'DA002008'
              MOVE VAL(CONT) TO D-FAUD-DA002008.
      *
           IF IDE(CONT) = 'DA002020'
              MOVE VAL(CONT) TO D-FAUD-DA002020.
           IF IDE(CONT) = 'DA002021'
              MOVE VAL(CONT) TO D-FAUD-DA002021.
           IF IDE(CONT) = 'DA002022'
              MOVE VAL(CONT) TO D-FAUD-DA002022.
           IF IDE(CONT) = 'DA002023'
              MOVE VAL(CONT) TO D-FAUD-DA002023.
      *
           IF IDE(CONT) = 'DA002024'
              MOVE VAL(CONT) TO D-FAUD-DA002024.
           IF IDE(CONT) = 'DA002025'
              MOVE VAL(CONT) TO D-FAUD-DA002025.
           IF IDE(CONT) = 'DA002026'
              MOVE VAL(CONT) TO D-FAUD-DA002026.
           IF IDE(CONT) = 'DA002027'
              MOVE VAL(CONT) TO D-FAUD-DA002027.
      *
           IF IDE(CONT) = 'DA002040'
              MOVE VAL(CONT) TO D-FAUD-DA002040.
           IF IDE(CONT) = 'DA002041'
              MOVE VAL(CONT) TO D-FAUD-DA002041.
           IF IDE(CONT) = 'DA002042'
              MOVE VAL(CONT) TO D-FAUD-DA002042.
      **** rel 7.2
      *    IF IDE(CONT) = 'DA002043'
           IF IDE(CONT) = 'DA002044'
      ************
              MOVE VAL(CONT) TO D-FAUD-DA002043.
      **** rel 7.2
           IF IDE(CONT) = 'DA002043'
              IF VAL(CONT)(16:1) = 1
                 MOVE 'X' TO D-FAUD-DA002SHU.
      ************
      *
           IF IDE(CONT) = 'DA003001'
              MOVE VAL(CONT)(9:2)  TO D-FAUD-DA003001gg
              MOVE VAL(CONT)(11:2) TO D-FAUD-DA003001mm
              MOVE VAL(CONT)(13:4) TO D-FAUD-DA003001aa
              IF VAL(CONT)(9:8) = ZERO
                   MOVE SPACE TO D-FAUD-DA003001gg D-FAUD-DA003001mm
                                 D-FAUD-DA003001aa.
      *
       SUMM.
           MOVE IDE(CONT) TO OLDIDE.
           ADD 1 TO CONTIDE.
           ADD 1 TO CONT.
           GO TO LEGGI-DATI.
       FINE-DATI.
           IF COM-FAUB-DANN = 1
              PERFORM SCR-REC THRU EX-SCR-REC
              MOVE ZERO TO NPAG.
      *
       EX-STAMPA-RECD.
           EXIT.
      *-------------------------------
       STRINGA-NEW.
           COMPUTE CARSTAR = 16 + (CONTIDE - 1 )* 15  + 1.
           IF IDE(CONT) = 'DA001002'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA001002(CARSTAR:15).
           IF IDE(CONT) = 'DA001003'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA001003(CARSTAR:15).
           IF IDE(CONT) = 'DA001004'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA001004(CARSTAR:15).
           IF IDE(CONT) = 'DA001007'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA001007(CARSTAR:15).
           IF IDE(CONT) = 'DA001009'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA001009(CARSTAR:15).
      *
           IF IDE(CONT) = 'DA002002'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA002002(CARSTAR:15).
           IF IDE(CONT) = 'DA002003'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA002003(CARSTAR:15).
           IF IDE(CONT) = 'DA002006'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA002006(CARSTAR:15).
      *
           IF IDE(CONT) = 'DA002020'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA002020(CARSTAR:15).
      *
           IF IDE(CONT) = 'DA002023'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA002023(CARSTAR:15).
      *
           IF IDE(CONT) = 'DA002041'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA002041(CARSTAR:15).
           IF IDE(CONT) = 'DA002042'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA002042(CARSTAR:15).
       EX-STRINGA-NEW.
           EXIT.
      *-------------------------------
      * carica separatore di campo
       CAR-SEPARATORE.
           MOVE SEPAR TO SP01 SP02 SP03 SP04 SP05 SP06 SP07 SP08 SP09 
                         SP10
                         SP11 SP12 SP13 SP14 SP15 SP16 SP17 SP18 SP19
                         SP20 
                         SP21 SP22 SP23 SP24 SP25 SP26 SP27 SP28 SP29
                         SP30
                         SP31 SP32 SP33 SP34 SP35 SP36 SP37 SP38 SP39
                         SP40
                         SP41 SP42 SP43 SP44 SP45 SP46 SP47 SP48 SP49
                         SP50
                         SP51 SP52 SP53 SP54 SP55 SP56 SP57 SP58 SP59
                         SP60
                         SP61 SP62 SP63 SP64 SP65 SP66 SP67 SP68 SP69
                         SP70 SP691
                         SP71 SP72 SP73 SP74 SP75 SP76 SP77 SP78 SP79
                         SP80
                         SP81 SP82 SP83 SP84 SP85 SP86 SP87 SP89
                         SP90
                         SP91 SP92 SP100 SP101 SP191 SP681 
      *
           MOVE 1 TO INDR.
       EX-CAR-SEPARATORE.
           EXIT.
      *-------------------------------
