       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRI2WRD.
      **** rel 7.1
      * Nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           SELECT FILAUT ASSIGN TO DISK
                  ORGANIZATION SEQUENTIAL
                  STATUS SF-FAU.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'grimaut'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parab'.
           COPY 'parwo'.
           COPY 'parrm'.
           COPY 'parop'.
           COPY 'parul'.
           COPY 'parrd'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-FAU PIC X(80) VALUE 'cru15'.
      *
       01  COMODI.
           05 SF-AZI     PIC XX.
           05 SF-FAU  PIC XX.
           05 NPAG       PIC 999.
           05 MESS       PIC X(40) VALUE SPACE.
           05 CODCLI     PIC 9(7).
           05 TIPPER     PIC 9.
           05 K          PIC 99.
           05 VETTORE-VALORI.
              10 VET-A PIC S9(11)V99 COMP-3 OCCURS 34.
           05 DATI-INTERI PIC X(1800).
           05 DATI-DIVISI REDEFINES DATI-INTERI OCCURS 75.
              10 IDE PIC X(8).
              10 VAL PIC X(16).
           05 CONT PIC 9(5).
           05 TOTPAG PIC 9(5).
           05 OLDREC PIC X.
           05 OLDIDE PIC X(8).
           05 CONTIDE PIC 9(5).
           05 CARSTAR PIC 9(5).
           05 K1      PIC 9(5).
           05 K2      PIC 9(5).
      **** rel 7.2
           05 ANNO    PIC 9(2).
      ************
      *
           05 COMFAUA.
              10 COM-FAUA-TRA    PIC X.
              10 COM-FAUA-FIL1   PIC X(14).
              10 COM-FAUA-CDF    PIC X(5).
              10 COM-FAUA-TFO    PIC 9(2).
              10 COM-FAUA-CFFO   PIC X(16).
              10 COM-FAUA-FIL2   PIC X(483).
              10 COM-FAUA-PRGI   PIC 9(4).
              10 COM-FAUA-TOTI   PIC 9(4).
              10 COM-FAUA-FIL5A  PIC X(1368).
              10 COM-FAUA-FIL6   PIC X.
              10 COM-FAUA-VACR   PIC X.
              10 COM-FAUA-VALF   PIC X.
           05 COMFAUB.
              10 COM-FAUB-TRB    PIC X.
              10 COM-FAUB-CFDI   PIC X(16).
              10 COM-FAUB-PRMO   PIC 9(8).
              10 COM-FAUB-FIL0   PIC X(1).
              10 COM-FAUB-FIL01  PIC X(8).
              10 COM-FAUB-NRPR   PIC X(25).
              10 COM-FAUB-IDDI   PIC X(14).
              10 COM-FAUB-PSWG   PIC X(16).
              10 COM-FAUB-FLGC   PIC X.
              10 COM-FAUB-DANN   PIC 9.
              10 COM-FAUB-DSOS   PIC 9.
              10 COM-FAUB-COGN   PIC X(24).
              10 COM-FAUB-NOME   PIC X(20).
              10 COM-FAUB-DENO   PIC X(60).
              10 COM-FAUB-EMAIL  PIC X(100).
              10 COM-FAUB-NTEL   PIC X(12).
              10 COM-FAUB-DEVE   PIC 9.
              10 COM-FAUB-CFISC  PIC X(16).
              10 COM-FAUB-CODC   PIC 9(2).
              10 COM-FAUB-CNF    PIC X(24).
              10 COM-FAUB-NOF    PIC X(20).
              10 COM-FAUB-CFSOC  PIC X(11).
              10 COM-FAUB-FILL80 PIC X(19).
              10 COM-FAUB-NAUT   PIC 9(8).
              10 COM-FAUB-QCT    PIC 9.
              10 COM-FAUB-FIRMA  PIC 9.
              10 COM-FAUB-CFISI  PIC X(16).
              10 COM-FAUB-IMPEG  PIC 9.
              10 COM-FAUB-DTIM   PIC 9(8).
              10 COM-FAUB-FIRMAI PIC 9.
              10 COM-FAUB-FIL22  PIC X(1).
              10 COM-FAUB-FIL24  PIC X(40).
              10 COM-FAUB-FIL25  PIC X(2).
              10 COM-FAUB-FIL26  PIC X(5).
              10 COM-FAUB-FIL27  PIC X(35).
              10 COM-FAUB-FIL28  PIC X(6).
              10 COM-FAUB-FIL29  PIC X(3).
              10 COM-FAUB-FIL30  PIC X(8).
              10 COM-FAUB-FIL31  PIC X(1).
              10 COM-FAUB-FIL32  PIC X(1305).
              10 COM-FAUB-FIL33  PIC X(20).
              10 COM-FAUB-FIL34  PIC X(7).
              10 COM-FAUB-FIL35  PIC X(3).
              10 COM-FAUB-FIL36  PIC X(3).
              10 COM-FAUB-FIL37  PIC X(1).
              10 COM-FAUB-FIL38  PIC X(1).
              10 COM-FAUB-FIL39  PIC X(1).
              10 COM-FAUB-FIL40  PIC X(1).
              10 COM-FAUB-FIL41  PIC X(1).
              10 COM-FAUB-FIL42  PIC X(1).
              10 COM-FAUB-FIL43  PIC X(15).
              10 COM-FAUB-FIL99  PIC X.
              10 COM-FAUB-VACR   PIC X.
              10 COM-FAUB-VALF   PIC X.
      *
           COPY 'vri2wrd.cpy'.
       LINKAGE SECTION.
           COPY 'parwri2'.
       PROCEDURE DIVISION USING PARWRI2 PARCCD.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==FAU==
                                   ==NFILE== BY ==FILAUT==
                                   =='nfile'== BY =='FILAUT'==.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
      *
           MOVE ZERO TO PCCD-ERR.

      * Inizializza
           IF PCCD-FUN = 'T' OR 'I'
              PERFORM PGM-INI THRU EX-PGM-INI.

      * Esegue
           IF PCCD-FUN = 'T' OR 'R'
              PERFORM PGM-RUN THRU EX-PGM-RUN.

      * Chiude
           IF PCCD-FUN = 'T' OR 'E'
              PERFORM PGM-END THRU EX-PGM-END
              GO TO CHIUDI.

           GO TO FINE.
       ERRIO.
           COPY 'errsub'.
           MOVE 9 TO PCCD-ERR.
           PERFORM WRD-CL.
       CHIUDI.
           CLOSE ANAAZI FILAUT.
       FINE.
           EXIT PROGRAM.
      *-------------------*
           COPY 'griwrd'.
      *-------------------*
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'grixxxer'.
      *------------------------------------------*
       PGM-END.
           PERFORM WRD-END.
       EX-PGM-END.
           EXIT.
      *------------------------------------------*
       PGM-INI.
           OPEN INPUT ANAAZI.
      *
           MOVE PWRI2-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
      *
           MOVE 'cerri2' TO WO-IDDOC.
           MOVE PWRI2-AZI TO WO-AZI.
           PERFORM WRD-INI.
       EX-PGM-INI.
           EXIT.
      *------------------------------------------*
       PGM-RUN.
           STRING PWRI2-NFILE DELIMITED SPACE INTO ID-FAU.
           OPEN INPUT FILAUT.
           IF SF-FAU NOT = ZERO
              MOVE 'FILE INESISTENTE' TO MESS
              GO TO ERRIO.
           IF SAVPATH = SPACE AND PCCD-PATH NOT = SPACE
              STRING PCCD-PATH DELIMITED SPACE
                     '\ri2'
                     PWRI2-AZI
                     '.doc'
                     DELIMITED SIZE INTO SAVPATH
              MOVE SAVPATH TO PCCD-PATH.
      *
           MOVE ZERO TO NPAG.
      *
           MOVE ZERO TO TOTPAG.
       INIZIO-CONTA.
           READ FILAUT AT END GO TO FINE-CONTA.
           IF RF-MFAU(1:1) = 'H'
              ADD 1 TO TOTPAG.
           GO TO INIZIO-CONTA.
       FINE-CONTA.
           CLOSE FILAUT.
      *
           OPEN INPUT FILAUT.
       INIZIO-LETTURA.
           READ FILAUT AT END GO TO FINE-LETTURA.
           IF RF-MFAU(1:1) = 'A'
              MOVE RF-MFAU TO COMFAUA.
           IF RF-MFAU(1:1) = 'B'
              MOVE RF-MFAU TO COMFAUB.
           IF RF-MFAU(1:1) = 'D'
              PERFORM STAMPA-RECA THRU EX-STAMPA-RECA
              PERFORM STAMPA-RECB THRU EX-STAMPA-RECB
              PERFORM STAMPA-RECD THRU EX-STAMPA-RECD.
           IF RF-MFAU(1:1) = 'H'
              PERFORM STAMPA-RECH THRU EX-STAMPA-RECH.
           GO TO INIZIO-LETTURA.
       FINE-LETTURA.
           CLOSE FILAUT.
       EX-PGM-RUN.
           EXIT.
      *------------------------------------------*
       SCR-REC.
           MOVE SPACE TO D-FLGS.
           IF PCCD-FLGS = 0
              MOVE 'S' TO D-FLGS.
           MOVE PCCD-PATH TO D-IDDOC.
      *
           PERFORM WRD-WR.
       EX-SCR-REC.
           EXIT.
      *-------------------------------
       STAMPA-RECA.
      *
           PERFORM WRD-AZZ.
      *
           ADD 1 TO NPAG.
      *
           MOVE 1       TO D-NCOP.
           MOVE SPACE   TO D-FAXT.
           MOVE TOTPAG  TO D-TOTPAG.    
           MOVE WD-TIPS TO D-TIPS.
      *
           MOVE COM-FAUA-CDF  TO D-FAUA-CDF.
           MOVE COM-FAUA-TFO  TO D-FAUA-TFO.
           MOVE COM-FAUA-CFFO TO D-FAUA-CFFO.
           MOVE COM-FAUA-PRGI TO D-FAUA-PRGI.
           MOVE COM-FAUA-TOTI TO D-FAUA-TOTI.
       EX-STAMPA-RECA.
           EXIT.
      *-------------------------------
       STAMPA-RECB.
           MOVE COM-FAUB-CFDI    TO D-FAUB-CFDI.
           MOVE COM-FAUB-PRMO    TO D-FAUB-PRMO.
           MOVE COM-FAUB-NRPR    TO D-FAUB-NRPR.
           MOVE COM-FAUB-IDDI    TO D-FAUB-IDDI.
           MOVE COM-FAUB-PSWG    TO D-FAUB-PSWG.
           MOVE COM-FAUB-FLGC    TO D-FAUB-FLGC.
           MOVE SPACE        TO D-FAUB-DANN.
           MOVE SPACE        TO D-FAUB-DSOS.
           MOVE SPACE        TO D-FAUB-DEVE.
      *
           IF COM-FAUB-DANN = 1
              MOVE 'X' TO D-FAUB-DANN.
           IF COM-FAUB-DSOS = 1
              MOVE 'X' TO D-FAUB-DSOS.
           IF COM-FAUB-DEVE NOT = ZERO
              MOVE COM-FAUB-DEVE TO D-FAUB-DEVE.
           MOVE COM-FAUB-COGN    TO D-FAUB-DENO.
           IF COM-FAUB-COGN = SPACE
              MOVE COM-FAUB-DENO TO D-FAUB-DENO.
           MOVE COM-FAUB-NOME    TO D-FAUB-NOME.
           MOVE COM-FAUB-EMAIL   TO D-FAUB-EMAIL.
           MOVE COM-FAUB-NTEL    TO D-FAUB-NTEL.
           MOVE COM-FAUB-CFISC   TO D-FAUB-CFISC.
           MOVE COM-FAUB-CODC    TO D-FAUB-CODC.
           MOVE COM-FAUB-CNF     TO D-FAUB-CNF.
           MOVE COM-FAUB-NOF     TO D-FAUB-NOF.
           MOVE COM-FAUB-CFSOC   TO D-FAUB-CFSOC.
           IF COM-FAUB-CFSOC = ZERO
              MOVE SPACE TO D-FAUB-CFSOC.
      *    MOVE COM-FAUB-NDIP    TO D-FAUB-NDIP.
           MOVE COM-FAUB-NAUT    TO D-FAUB-NAUT.
           MOVE COM-FAUB-QCT     TO D-FAUB-QCT.
           MOVE PWRI2-FIRMA      TO D-FAUB-FIRMA.
           MOVE COM-FAUB-CFISI   TO D-FAUB-CFISI.
           MOVE COM-FAUB-IMPEG   TO D-FAUB-IMPEG.
           IF D-FAUB-IMPEG = ZERO
              MOVE SPACE TO D-FAUB-IMPEG.
           MOVE COM-FAUB-DTIM(1:2) TO D-FAUB-DTIMgg.
           MOVE COM-FAUB-DTIM(3:2) TO D-FAUB-DTIMmm.
           MOVE COM-FAUB-DTIM(5:4) TO D-FAUB-DTIMaa.
           IF COM-FAUB-DTIM = ZERO
                   MOVE SPACE TO D-FAUB-DTIMgg D-FAUB-DTIMmm
                                 D-FAUB-DTIMaa.
           MOVE COM-FAUB-FIRMAI  TO D-FAUB-FIRMAI.
       EX-STAMPA-RECB.
           EXIT.
      *-------------------------------
       STAMPA-RECH.
           MOVE SPACE     TO DATI-INTERI.
           MOVE FAUH-FIL1 TO DATI-INTERI.
           MOVE 1 TO CONT. 
           MOVE ZERO TO CONTIDE.
           MOVE SPACE TO OLDIDE.
       LEGGI-DATI2.
           IF IDE(CONT) = SPACE
              GO TO FINE-DATI2.
           IF IDE(CONT) = OLDIDE
              PERFORM STRINGA-NEW THRU EX-STRINGA-NEW
              GO TO SUMM2
           ELSE
              MOVE ZERO TO CONTIDE.
      *
           IF IDE(CONT) = 'AU001001'
              MOVE VAL(CONT) TO D-FAUH-AU001001.
           IF IDE(CONT) = 'AU001002'
              MOVE VAL(CONT)(13:4) TO D-FAUH-AU001002.
           IF IDE(CONT) = 'AU001003'
              IF VAL(CONT)(16:1) = '0'
                 MOVE SPACE TO D-FAUH-AU001003
              ELSE
                 MOVE 'X'   TO D-FAUH-AU001003.
           IF IDE(CONT) = 'AU001004'
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001004.
           IF IDE(CONT) = 'AU001005'
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001005.
           IF IDE(CONT) = 'AU001006'
              MOVE VAL(CONT)(16:1) TO D-FAUH-AU001006.
           IF IDE(CONT) = 'AU001007'
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001007.
           IF IDE(CONT) = 'AU001008'
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001008.
           IF IDE(CONT) = 'AU001009'
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001009.
           IF IDE(CONT) = 'AU001010'
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001010.
           IF IDE(CONT) = 'AU001011'
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001011.
      **** rel 7.2
      *    IF IDE(CONT) = 'AU001020'
           IF IDE(CONT) = 'AU001034'
      ************
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001020.
      **** rel 7.2
      *    IF IDE(CONT) = 'AU001021'
           IF IDE(CONT) = 'AU001035'
      ************
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001021.
      **** rel 7.2
      *    IF IDE(CONT) = 'AU001022'
           IF IDE(CONT) = 'AU001020'
      ************
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001022.
      **** rel 7.2
      *    IF IDE(CONT) = 'AU001023'
           IF IDE(CONT) = 'AU001021'
      ************
              IF VAL(CONT) = '            0,00' MOVE SPACE TO VAL(CONT) 
              END-IF
              MOVE VAL(CONT) TO D-FAUH-AU001023.
      *
      **** rel 7.2
           IF IDE(CONT) = 'AU001071'
              MOVE VAL(CONT) TO D-FAUH-AU001071.
      *
      ************
       SUMM2.
           MOVE IDE(CONT) TO OLDIDE.
           ADD 1 TO CONTIDE.
           ADD 1 TO CONT.
           GO TO LEGGI-DATI2.
       FINE-DATI2.
      *
           PERFORM SCR-REC THRU EX-SCR-REC.
           MOVE ZERO TO NPAG.
       EX-STAMPA-RECH.
           EXIT.
      *-------------------------------
       STAMPA-RECD.
           MOVE FAUD-PRGC TO D-FAUD-NRMO.
           MOVE SPACE TO D-FAUD-TOPES D-FAUD-TOPEA.
           IF FAUD-TOPE NOT = SPACE
              IF FAUD-TOPE = 'S'
                 MOVE 'X' TO D-FAUD-TOPES
              ELSE
                 MOVE 'X' TO D-FAUD-TOPEA.
      *
           MOVE 20 TO D-FAUD-ANNOF(1:2).
           MOVE COM-FAUA-CDF(4:2) TO ANNO.
           COMPUTE ANNO = ANNO - 1.
           MOVE ANNO TO D-FAUD-ANNOF(3:2).
           
      *
           MOVE SPACE     TO DATI-INTERI.
           MOVE FAUD-FIL1 TO DATI-INTERI.
           MOVE 1 TO CONT. 
           MOVE ZERO TO CONTIDE.
           MOVE SPACE TO OLDIDE.
       LEGGI-DATI.
           IF IDE(CONT) = SPACE
              GO TO FINE-DATI.
           IF IDE(CONT) = OLDIDE
              PERFORM STRINGA-NEW THRU EX-STRINGA-NEW
              GO TO SUMM
           ELSE
              MOVE ZERO TO CONTIDE.
      *
           IF IDE(CONT) = 'DA001001'
              MOVE VAL(CONT) TO D-FAUD-DA001001.
           IF IDE(CONT) = 'DA001002'
              MOVE VAL(CONT) TO D-FAUD-DA001002.
           IF IDE(CONT) = 'DA001003'
              MOVE VAL(CONT) TO D-FAUD-DA001003.
           IF IDE(CONT) = 'DA001004'
              MOVE VAL(CONT) TO D-FAUD-DA001004.
           IF IDE(CONT) = 'DA001005'
              MOVE VAL(CONT) TO D-FAUD-DA001005.
           IF IDE(CONT) = 'DA001006'
              MOVE VAL(CONT) TO D-FAUD-DA001006.
           IF IDE(CONT) = 'DA001007'
              MOVE VAL(CONT) TO D-FAUD-DA001007.
           IF IDE(CONT) = 'DA001008'
              MOVE VAL(CONT) TO D-FAUD-DA001008.
           IF IDE(CONT) = 'DA001009'
              MOVE VAL(CONT) TO D-FAUD-DA001009.
           IF IDE(CONT) = 'DA001010'
              MOVE VAL(CONT) TO D-FAUD-DA001010.
      *
           IF IDE(CONT) = 'DA002001'
              MOVE VAL(CONT) TO D-FAUD-DA002001.
           IF IDE(CONT) = 'DA002002'
              MOVE VAL(CONT) TO D-FAUD-DA002002.
           IF IDE(CONT) = 'DA002003'
              MOVE VAL(CONT) TO D-FAUD-DA002003.
           IF IDE(CONT) = 'DA002005'
              MOVE VAL(CONT)(9:2)  TO D-FAUD-DA002005gg
              MOVE VAL(CONT)(11:2) TO D-FAUD-DA002005mm
              MOVE VAL(CONT)(13:4) TO D-FAUD-DA002005aa
              IF VAL(CONT)(9:8) = ZERO
                   MOVE SPACE TO D-FAUD-DA002005gg D-FAUD-DA002005mm
                                 D-FAUD-DA002005aa.
           IF IDE(CONT) = 'DA002004'
              MOVE VAL(CONT) TO D-FAUD-DA002004.
           IF IDE(CONT) = 'DA002006'
              MOVE VAL(CONT) TO D-FAUD-DA002006.
           IF IDE(CONT) = 'DA002007'
              MOVE VAL(CONT) TO D-FAUD-DA002007.
           IF IDE(CONT) = 'DA002008'
              MOVE VAL(CONT) TO D-FAUD-DA002008.
      *
           IF IDE(CONT) = 'DA002020'
              MOVE VAL(CONT) TO D-FAUD-DA002020.
           IF IDE(CONT) = 'DA002021'
              MOVE VAL(CONT) TO D-FAUD-DA002021.
           IF IDE(CONT) = 'DA002022'
              MOVE VAL(CONT) TO D-FAUD-DA002022.
           IF IDE(CONT) = 'DA002023'
              MOVE VAL(CONT) TO D-FAUD-DA002023.
      *
           IF IDE(CONT) = 'DA002024'
              MOVE VAL(CONT) TO D-FAUD-DA002024.
           IF IDE(CONT) = 'DA002025'
              MOVE VAL(CONT) TO D-FAUD-DA002025.
           IF IDE(CONT) = 'DA002026'
              MOVE VAL(CONT) TO D-FAUD-DA002026.
           IF IDE(CONT) = 'DA002027'
              MOVE VAL(CONT) TO D-FAUD-DA002027.
      *
           IF IDE(CONT) = 'DA002040'
              MOVE VAL(CONT) TO D-FAUD-DA002040.
           IF IDE(CONT) = 'DA002041'
              MOVE VAL(CONT) TO D-FAUD-DA002041.
           IF IDE(CONT) = 'DA002042'
              MOVE VAL(CONT) TO D-FAUD-DA002042.
      **** rel 7.2
      *    IF IDE(CONT) = 'DA002043'
           IF IDE(CONT) = 'DA002044'
      ************
              MOVE VAL(CONT) TO D-FAUD-DA002043.
      **** rel 7.2
           IF IDE(CONT) = 'DA002043'
              IF VAL(CONT)(16:1) = 1
                 MOVE 'X' TO D-FAUD-DA002SHU.
      ************
      *
           IF IDE(CONT) = 'DA003001'
              MOVE VAL(CONT)(9:2)  TO D-FAUD-DA003001gg
              MOVE VAL(CONT)(11:2) TO D-FAUD-DA003001mm
              MOVE VAL(CONT)(13:4) TO D-FAUD-DA003001aa
              IF VAL(CONT)(9:8) = ZERO
                   MOVE SPACE TO D-FAUD-DA003001gg D-FAUD-DA003001mm
                                 D-FAUD-DA003001aa.
      *
       SUMM.
           MOVE IDE(CONT) TO OLDIDE.
           ADD 1 TO CONTIDE.
           ADD 1 TO CONT.
           GO TO LEGGI-DATI.
       FINE-DATI.
           IF COM-FAUB-DANN = 1
              PERFORM SCR-REC THRU EX-SCR-REC
              MOVE ZERO TO NPAG.
      *
       EX-STAMPA-RECD.
           EXIT.
      *-------------------------------
       STRINGA-NEW.
           COMPUTE CARSTAR = 16 + (CONTIDE - 1 )* 15  + 1.
           IF IDE(CONT) = 'DA001002'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA001002(CARSTAR:15).
           IF IDE(CONT) = 'DA001003'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA001003(CARSTAR:15).
           IF IDE(CONT) = 'DA001004'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA001004(CARSTAR:15).
           IF IDE(CONT) = 'DA001007'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA001007(CARSTAR:15).
           IF IDE(CONT) = 'DA001009'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA001009(CARSTAR:15).
      *
           IF IDE(CONT) = 'DA002002'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA002002(CARSTAR:15).
           IF IDE(CONT) = 'DA002003'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA002003(CARSTAR:15).
           IF IDE(CONT) = 'DA002006'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA002006(CARSTAR:15).
      *
           IF IDE(CONT) = 'DA002020'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA002020(CARSTAR:15).
      *
           IF IDE(CONT) = 'DA002023'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA002023(CARSTAR:15).
      *
           IF IDE(CONT) = 'DA002041'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA002041(CARSTAR:15).
           IF IDE(CONT) = 'DA002042'
              MOVE VAL(CONT)(2:15) TO D-FAUD-DA002042(CARSTAR:15).
       EX-STRINGA-NEW.
           EXIT.
      *-------------------------------
